﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        private const int EXTRA_WIDTH = 400;
        private int oldX;

        public Form1()
        {
            InitializeComponent();
            Shown += Form1_Resize;
        }

        private void panel2_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                int newX = panel2.Left + e.X - oldX;
                if (newX > 0)
                {
                    newX = 0;
                }
                else if (newX < -EXTRA_WIDTH - 10)
                {
                    newX = -EXTRA_WIDTH - 10;
                }
                panel2.Left = newX;

                imgScrollBar.Left = -panel2.Left;
                imgScrollBar.Refresh();
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            panel2.Location = new Point(0, 0);
            panel2.Width = Width + EXTRA_WIDTH;
        }

        private void imgScrollBar_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.FillRectangle(Brushes.White, e.ClipRectangle);
            int xLeft = (int)Math.Round(imgScrollBar.Width / (double)panel2.Width * -panel2.Left);
            int xRight = (int)Math.Round(imgScrollBar.Width / (double)panel2.Width * (-panel2.Left + panel2.Parent.Width));
            //Rectangle r = new Rectangle(xLeft, 0, xRight - xLeft, imgScrollBar.Height);
            //e.Graphics.FillRectangle(Brushes.Black, r);
            e.Graphics.FillCircle(Brushes.Black, xLeft, 0, 6);
            e.Graphics.FillCircle(Brushes.Black, xRight, 0, 6);
        }

        private void panel2_MouseDown(object sender, MouseEventArgs e)
        {
            oldX = e.X;
        }

        private void panel2_Resize(object sender, EventArgs e)
        {
            imgScrollBar.Left = -panel2.Left;
            imgScrollBar.Width = panel2.Parent.Width - 6;
        }
    }
}
